Package org.springframework.web.servlet.view.feed

# Class AbstractAtomFeedView

java.lang.Object
org.springframework.context.support.ApplicationObjectSupport
org.springframework.web.context.support.WebApplicationObjectSupport
org.springframework.web.servlet.view.AbstractView
org.springframework.web.servlet.view.feed.AbstractFeedView<com.rometools.rome.feed.atom.Feed>
org.springframework.web.servlet.view.feed.AbstractAtomFeedView

All Implemented Interfaces:
  `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.context.ApplicationContextAware`, `org.springframework.web.context.ServletContextAware`, `View`

public abstract class AbstractAtomFeedView extends AbstractFeedView<com.rometools.rome.feed.atom.Feed>
Abstract superclass for Atom Feed views, using the ROME package.

NOTE: As of Spring 4.1, this is based on the `com.rometools` variant of ROME, version 1.5. Please upgrade your build dependency.

Application-specific view classes will extend this class. The view will be held in the subclass itself, not in a template. Main entry points are the `AbstractFeedView.buildFeedMetadata(java.util.Map<java.lang.String, java.lang.Object>, T, jakarta.servlet.http.HttpServletRequest)` and `buildFeedEntries(java.util.Map<java.lang.String, java.lang.Object>, com.rometools.rome.feed.atom.Feed, jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse)`.

Thanks to Jettro Coenradie and Sergio Bossa for the original feed view prototype!

Since:
  3.0
Author:
  Arjen Poutsma, Juergen Hoeller
See Also:
  - `AbstractFeedView.buildFeedMetadata(java.util.Map<java.lang.String, java.lang.Object>, T, jakarta.servlet.http.HttpServletRequest)`
  - `buildFeedEntries(java.util.Map<java.lang.String, java.lang.Object>, com.rometools.rome.feed.atom.Feed, jakarta.servlet.http.HttpServletRequest, jakarta.servlet.http.HttpServletResponse)`
  - Atom Syndication Format

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_FEED_TYPE`
The default feed type used.

### Fields inherited from class org.springframework.web.servlet.view.AbstractView

`DEFAULT_CONTENT_TYPE`

### Fields inherited from class org.springframework.context.support.ApplicationObjectSupport

`logger`

### Fields inherited from interface org.springframework.web.servlet.View

`PATH_VARIABLES, RESPONSE_STATUS_ATTRIBUTE, SELECTED_CONTENT_TYPE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractAtomFeedView()`

## Method Summary

Modifier and Type
Method
Description
`protected final void`
`buildFeedEntries(Map<String,Object> model, com.rometools.rome.feed.atom.Feed feed, HttpServletRequest request, HttpServletResponse response)`
Invokes `buildFeedEntries(Map, HttpServletRequest, HttpServletResponse)` to get a list of feed entries.
`protected abstract List<com.rometools.rome.feed.atom.Entry>`
`buildFeedEntries(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)`
Subclasses must implement this method to build feed entries, given the model.
`protected com.rometools.rome.feed.atom.Feed`
`newFeed()`
Create a new Feed instance to hold the entries.
`void`
`setFeedType(String feedType)`
Set the Rome feed type to use.

### Methods inherited from class org.springframework.web.servlet.view.feed.AbstractFeedView

`buildFeedMetadata, renderMergedOutputModel`

### Methods inherited from class org.springframework.web.servlet.view.AbstractView

`addStaticAttribute, createMergedOutputModel, createRequestContext, createTemporaryOutputStream, exposeModelAsRequestAttributes, formatViewName, generatesDownloadContent, getAttributesMap, getBeanName, getContentType, getRequestContextAttribute, getRequestToExpose, getStaticAttributes, isExposePathVariables, prepareResponse, render, setAttributes, setAttributesCSV, setAttributesMap, setBeanName, setContentType, setExposeContextBeansAsAttributes, setExposedContextBeanNames, setExposePathVariables, setRequestContextAttribute, setResponseContentType, toString, writeToResponse`

### Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport

`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

### Methods inherited from class org.springframework.context.support.ApplicationObjectSupport

`getApplicationContext, getMessageSourceAccessor, initApplicationContext, obtainApplicationContext, requiredContextClass, setApplicationContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### DEFAULT_FEED_TYPE

public static final String DEFAULT_FEED_TYPE
The default feed type used.

See Also:
  - Constant Field Values

## Constructor Details

### AbstractAtomFeedView

public AbstractAtomFeedView()

## Method Details

### setFeedType

public void setFeedType(String feedType)
Set the Rome feed type to use.

Defaults to Atom 1.0.

See Also:
  - `WireFeed.setFeedType(String)`
  - `DEFAULT_FEED_TYPE`

### newFeed

protected com.rometools.rome.feed.atom.Feed newFeed()
Create a new Feed instance to hold the entries.

By default returns an Atom 1.0 feed, but the subclass can specify any Feed.

Specified by:
  `newFeed` in class `AbstractFeedView<com.rometools.rome.feed.atom.Feed>`
Returns:
  the newly created Feed instance
See Also:
  - `setFeedType(String)`

### buildFeedEntries

protected final void buildFeedEntries(Map<String,Object> model, com.rometools.rome.feed.atom.Feed feed, HttpServletRequest request, HttpServletResponse response) throws Exception
Invokes `buildFeedEntries(Map, HttpServletRequest, HttpServletResponse)` to get a list of feed entries.

Specified by:
  `buildFeedEntries` in class `AbstractFeedView<com.rometools.rome.feed.atom.Feed>`
Parameters:
  `model` - the model Map
  `feed` - the feed to add entries to
  `request` - in case we need locale etc. Shouldn't look at attributes.
  `response` - in case we need to set cookies. Shouldn't write to it.
Throws:
  `Exception` - any exception that occurred during building

### buildFeedEntries

protected abstract List<com.rometools.rome.feed.atom.Entry> buildFeedEntries(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response) throws Exception
Subclasses must implement this method to build feed entries, given the model.

Note that the passed-in HTTP response is just supposed to be used for setting cookies or other HTTP headers. The built feed itself will automatically get written to the response after this method returns.

Parameters:
  `model` - the model Map
  `request` - in case we need locale etc. Shouldn't look at attributes.
  `response` - in case we need to set cookies. Shouldn't write to it.
Returns:
  the feed entries to be added to the feed
Throws:
  `Exception` - any exception that occurred during document building
See Also:
  - `Entry`